hdu 2955 Robberies(01背包)

Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

hdu 2955 Robberies(01背包)_第1张图片
For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

Sample Input

        
        
        
        
3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
 

Sample Output

        
        
        
        
2 4 6
 

题目大意:有个人要去强银行,然后他统计了抢各个银行被抓的概率和可以抢到的钱数,要求在给定的概率下求最多可以抢多少钱。

解题思路:这题很明显的01背包,训练赛的时候一看到就知道了,可惜基础不扎实,想不起来怎么做了。

这道题目有个特殊的地方就是说以概率做要求,概率是浮点数,不可以用来做下标,所以这能换个方向去思考,以钱数做背包容量,求出每个可抢到金额的最优不被抓概率。

#include <stdio.h>
#include <string.h>

const int N  = 10010;
double pro, probal[N], dp[N];
int n, value[N];

double bo_max(double a, double b) {
    return a > b? a:b;
}

int solve() {
    memset(dp, 0, sizeof(dp));
    dp[0] = 1;
    for (int i = 0; i < n; i++) {
	for (int j = N; j >= value[i]; j--)
	    dp[j] = bo_max(dp[j], dp[j - value[i]] * (1.0 - probal[i]));
    }

    for (int i = N - 1; i >= 0; i--)
	if (dp[i] > (1.0 - pro))
		return i;
}

int main() {
    int cas;
    scanf("%d", &cas);
    while (cas--) {
	scanf("%lf%d", &pro, &n);

	for (int i = 0; i < n; i++)
	    scanf("%d%lf", &value[i], &probal[i]);

	printf("%d\n", solve());
    }
   return 0;}

你可能感兴趣的:(hdu 2955 Robberies(01背包))